Overview in EJ2 JavaScript Diagram

07 Aug 202615 minutes to read

The Overview control allows you to see a preview or an overall view of the entire content of a diagram. This helps you to grasp the overall picture of a large diagram and navigate, pan, or zoom to a specific position on the page.

Usage scenario

When working on a very large diagram, it can be challenging to know which part you are actually focusing on or to navigate from one section to another. One solution for navigation is to zoom out to view the entire diagram and locate your position. Then, you can zoom in on the specific area you need. However, this method is not ideal for frequent navigation.

The Overview control addresses these issues by providing a preview, or overall view, of the entire diagram. A rectangle indicates the viewport of the diagram, making navigation easy by dragging this rectangle to the desired section.

Create overview

To create an overview, the sourceID property of the overview should be set with the corresponding diagram Id for the overall view.

The width and height properties of the overview allow you to define its size.

The following code illustrates how to create an overview:

/**
 * OverView
 */

 // Initializtion of the diagram.
 let diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '790px',
    nodes: [{ id: 'node1', offsetX: 400, offsetY: 400, height: 100, width: 200 }],
    scrollSettings: { scrollLimit: 'Diagram' },
    // Sets the constraints of the SnapSettings
    snapSettings: { constraints: ej.diagrams.SnapConstraints.None },
  });
  diagram.appendTo('#element');
  
  // Initializtion of the Overview.
  let overview = new ej.diagrams.Overview({
    width: '300px',
    height: '150ppx',
    sourceID: 'element',
  });
  overview.appendTo('#overview');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container" style="width: 100%; display: flex">
        <div id="element" style="flex: 7"></div>
        <div
          id="overview"
          style="
            flex: 3;
            height: 250px;
            padding: 0px;
            right: 30px;
            bottom: 20px;
            border: #eeeeee;
            border-style: solid;
            box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
            background: #f7f7f7;
          "
        ></div>
      </div><script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Overview interactions

In the overview, the viewport of the diagram is highlighted with a red color rectangle. You can zoom and pan the diagram by interacting with this rectangle.

You can interact with the overview as follows:

  • Resize the rectangle: Zooms in/out of the diagram.
  • Drag the rectangle: Pans the diagram.
  • Click on a position: Navigates to the clicked region.
  • Select a specific region by clicking and dragging: Navigates to the specified region.
ej.diagrams.Diagram.Inject(
    ej.diagrams.DataBinding,
    ej.diagrams.HierarchicalTree,
    ej.diagrams.LayoutAnimation
  );
  /**
   * hierarchical-model
   */
  //Click event for Appearance of the Property Panel.
  
  //sets node default value

  var hierarchicalTree = [
    {
      Name: 'Diagram',
      fillColor: '#916DAF',
    },
    {
      Name: 'Layout',
      Category: 'Diagram',
    },
    {
      Name: 'Tree Layout',
      Category: 'Layout',
    },
    {
      Name: 'Organizational Chart',
      Category: 'Layout',
    },
    {
      Name: 'Hierarchical Tree',
      Category: 'Tree Layout',
    },
    {
      Name: 'Radial Tree',
      Category: 'Tree Layout',
    },
    {
      Name: 'Mind Map',
      Category: 'Hierarchical Tree',
    },
    {
      Name: 'Family Tree',
      Category: 'Hierarchical Tree',
    },
    {
      Name: 'Management',
      Category: 'Organizational Chart',
    },
    {
      Name: 'Human Resources',
      Category: 'Management',
    },
    {
      Name: 'University',
      Category: 'Management',
    },
    {
      Name: 'Business',
      Category: 'Management',
    },
  ];

  function nodeDefaults(obj, diagram) {
    obj.style = {
      fill: '#659be5',
      strokeColor: 'none',
      color: 'white',
      strokeWidth: 2,
    };
    obj.borderColor = '#3a6eb5';
    obj.backgroundColor = '#659be5';
    obj.width = 150;
    obj.height = 50;
    obj.expandIcon = {
      height: 10,
      width: 10,
      shape: 'None',
      fill: 'lightgray',
      offset: { x: 0.5, y: 1 },
    };
    obj.expandIcon.verticalAlignment = 'Auto';
    obj.expandIcon.margin = { left: 0, right: 0, top: 0, bottom: 0 };
    obj.collapseIcon.offset = { x: 0.5, y: 1 };
    obj.collapseIcon.verticalAlignment = 'Auto';
    obj.collapseIcon.margin = { left: 0, right: 0, top: 0, bottom: 0 };
    obj.collapseIcon.height = 10;
    obj.collapseIcon.width = 10;
    obj.collapseIcon.padding.top = 5;
    obj.collapseIcon.shape = 'None';
    obj.collapseIcon.fill = 'lightgray';
    return obj;
  }
  //sets connector default value
  function connectorDefaults(connector, diagram) {
    connector.targetDecorator.shape = 'None';
    connector.type = 'Orthogonal';
    connector.style.strokeColor = '#6d6d6d';
    connector.constraints = 0;
    connector.cornerRadius = 5;
    return connector;
  }
  
  // tslint:disable-next-line:max-func-body-length
  
  //Initializes the nodes for the diagram
  var diagram = new ej.diagrams.Diagram({
    width: '100%',
    height: '499px',
    snapSettings: { constraints: ej.diagrams.SnapConstraints.None },
    //configures data source settings
    dataSourceSettings: {
      id: 'Name',
      parentId: 'Category',
      dataSource: new ej.data.DataManager(hierarchicalTree),
      doBinding: function (nodeModel, data, diagram) {
        nodeModel.shape = { type: 'Text', content: data.Name };
      },
    },
    //Disables all interactions except zoom/pan
    tool: ej.diagrams.DiagramTools.ZoomPan,
    //Configures automatic layout
    layout: {
      type: 'HierarchicalTree',
      verticalSpacing: 30,
      horizontalSpacing: 40,
      enableAnimation: true,
    },
    //Defines the default node and connector properties
    getNodeDefaults: function (obj, diagram) {
      return nodeDefaults(obj, diagram);
    },
    getConnectorDefaults: function (connector, diagram) {
      return connectorDefaults(connector, diagram);
    },
  });
  diagram.appendTo('#element');
  // Initializtion of the Overview.
  let overview = new ej.diagrams.Overview({
    width: '100%',
    height: '250px',
    sourceID: 'element',
  });
  overview.appendTo('#overview');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div class="container" style="width: 100%">
        <div id="element"></div>
        <div
          class="col-lg-4"
          style="
            width: 35%;
            padding: 0px;
            right: 30px;
            bottom: 10px;
            border: #eeeeee;
            border-style: solid;
            box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
            background: #f7f7f7;
          "
        >
          <div id="overview" style="top: 30px"></div>
        </div>
      </div><script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

The following Gif image displays the interactions with overview.

Overview-interaction

Overview in React Diagram

01 Sep 202624 minutes to read

The Overview component provides a miniature preview of the entire React Diagram content, enabling efficient navigation and viewport management for large diagrams. This component displays a scaled-down version of the diagram with a highlighted rectangle representing the current viewport, allowing users to quickly navigate to specific areas without manual zooming and panning.

When to Use Overview

The Overview component is essential when working with:

  • Large diagrams that exceed the visible viewport.
  • Complex flowcharts or organizational charts requiring frequent navigation.
  • Multi-section diagrams where users need to jump between different areas.
  • Applications where users need spatial awareness of their current position within the diagram.

Create Overview Component

To implement an overview, configure the sourceID property to reference the target diagram’s identifier. This establishes the connection between the overview and the main diagram. The target DiagramComponent must have a valid id and be rendered in the DOM before the Overview binds to it via sourceID.

Define the overview dimensions using the width and height properties to ensure optimal visibility and performance. For the complete list of available properties, see the Overview API reference. The example below also sets snapSettings to SnapConstraints.None and defines a NodeModel array to populate the diagram.

The following code demonstrates a basic overview implementation. The component is rendered to the DOM using ReactDOM.createRoot(...).render(<App />).

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { DiagramComponent, OverviewComponent, SnapConstraints } from '@syncfusion/ej2-react-diagrams';

// A node is created and stored in nodes array.
let node = [
  { id: 'node1', offsetX: 400, offsetY: 400, height: 100, width: 200 },
];
// Initializes the Diagram control
function App() {
  return (
    <div style=>
      <div style=>
        <DiagramComponent
          id="container"
          height={'790px'}
          width={'100%'}
          nodes={node}
          scrollSettings=
          // Sets the constraints of the SnapSettings
          snapSettings=
        ></DiagramComponent>
      </div>
      <div
        style=
      >
        <OverviewComponent
          id="overview"
          sourceID="container"
          width={'300px'}
          height={'150px'}
        />
      </div>
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, OverviewComponent, NodeModel, SnapConstraints } from '@syncfusion/ej2-react-diagrams';
// A node is created and stored in nodes array.
let node: NodeModel[] = [ { id: 'node1', offsetX: 400, offsetY: 400, height: 100, width: 200 },];
// Initializes the Diagram control
function App() {
  return (
    <div style=>
    <div style=>
      <DiagramComponent
        id="container"
        height={'790px'}
        width={'100%'}
        nodes={node}
        scrollSettings=
        // Sets the constraints of the SnapSettings
        snapSettings=
      ></DiagramComponent>
    </div>
    <div
      style=
    >
      <OverviewComponent
        id="overview"
        sourceID="container"
        width={'300px'}
        height={'150px'}
      />
    </div>
  </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Overview Interactions

The overview displays the current viewport as a red rectangle overlay. This rectangle serves as an interactive control for diagram navigation and zoom operations. These interactions are enabled by default; no additional configuration or code is required to enable drag, resize, or click navigation when the Overview is bound to a diagram.

Available Interactions

  • Resize the rectangle: Adjusts diagram zoom level proportionally.
  • Drag the rectangle: Pans the diagram to follow rectangle movement.
  • Click on a position: Instantly navigates to the clicked location.
  • Click and drag selection: Defines a specific region for navigation and zoom.

Interactive Navigation Example

import * as React from "react";
import { createRoot } from 'react-dom/client';
import { DataManager, Query } from '@syncfusion/ej2-data';
import { StackPanel, TextElement, DataBinding, OverviewComponent, HierarchicalTree, DiagramTools, DiagramComponent, Inject } from "@syncfusion/ej2-react-diagrams";
/**
 * Overview
 */

let data = [{
        'Id': 'parent',
        'Name': 'Maria Anders',
        'Designation': 'Managing Director',
        'IsExpand': 'true',
        'RatingColor': '#C34444'
    },
    {
        'Id': 1,
        'Name': 'Ana Trujillo',
        'Designation': 'Project Manager',
        'IsExpand': 'false',
        'RatingColor': '#68C2DE',
        'ReportingPerson': 'parent'
    },
    {
        'Id': 2,
        'Name': 'Anto Moreno',
        'Designation': 'Project Lead',
        'IsExpand': 'false',
        'RatingColor': '#93B85A',
        'ReportingPerson': 'parent'
    },
    {
        'Id': 3,
        'Name': 'Thomas Hardy',
        'Designation': 'Senior S/w Engg',
        'IsExpand': 'false',
        'RatingColor': '#68C2DE',
        'ReportingPerson': 1
    },
    {
        'Id': 4,
        'Name': 'Christina kaff',
        'Designation': 'S/w Engg',
        'IsExpand': 'false',
        'RatingColor': '#93B85A',
        'ReportingPerson': 2
    },
    {
        'Id': 5,
        'Name': 'Hanna Moos',
        'Designation': 'Project Trainee',
        'IsExpand': 'true',
        'RatingColor': '#D46E89',
        'ReportingPerson': 2
    },
];
let diagramInstance;
let items = new DataManager(data, new Query().take(7));
let layout = {
    type: 'HierarchicalTree',
    margin: {
        top: 20
    },
    getLayoutInfo: (node, tree) => {
        if (!tree.hasSubTree) {
            tree.orientation = 'Vertical';
            tree.type = 'Alternate';
        }
    },
}
// Initializes the Diagram control
function App() {
    return (<>
      <div style=>
        <DiagramComponent id="container" ref={(diagram) => (diagramInstance = diagram)} height={'499px'}  created={() => {
        //To draw an object once, activate draw once
        diagramInstance.tool = DiagramTools.ZoomPan;
        diagramInstance.dataBind();
      }}
      layout={layout} dataSourceSettings= getNodeDefaults={(node) => {
            node.height = 50;
            node.style.fill = '#6BA5D7';
            node.borderColor = 'white';
            node.style.strokeColor = 'white';
            return node;
        }} getConnectorDefaults={(obj) => {
            obj.style.strokeColor = '#6BA5D7';
            obj.style.fill = '#6BA5D7';
            obj.style.strokeWidth = 2;
            obj.targetDecorator.style.fill = '#6BA5D7';
            obj.targetDecorator.style.strokeColor = '#6BA5D7';
            obj.targetDecorator.shape = 'None';
            obj.type = 'Orthogonal';
            return obj;
        }} setNodeTemplate={(obj, diagram) => {
            let content = new StackPanel();
            content.id = obj.id + '_outerstack';
            content.style.strokeColor = 'darkgreen';
            content.style.fill = '#6BA5D7';
            content.orientation = 'Horizontal';
            content.padding = {
                left: 5,
                right: 10,
                top: 5,
                bottom: 5,
            };
            let innerStack = new StackPanel();
            innerStack.style.strokeColor = 'none';
            innerStack.style.fill = '#6BA5D7';
            innerStack.margin = {
                left: 5,
                right: 0,
                top: 0,
                bottom: 0,
            };
            innerStack.id = obj.id + '_innerstack';
            let text = new TextElement();
            text.content = obj.data['Name'];
            text.style.color = 'white';
            text.style.strokeColor = 'none';
            text.style.fill = 'none';
            text.id = obj.id + '_text1';
            let desigText = new TextElement();
            desigText.margin = {
                left: 0,
                right: 0,
                top: 5,
                bottom: 0,
            };
            desigText.content = obj.data['Designation'];
            desigText.style.color = 'white';
            desigText.style.strokeColor = 'none';
            desigText.style.fill = 'none';
            desigText.style.textWrapping = 'Wrap';
            desigText.id = obj.id + '_desig';
            innerStack.children = [text, desigText];
            content.children = [innerStack];
            return content;
        }}>
          <Inject services={[DataBinding, HierarchicalTree]}/>
        </DiagramComponent>
      </div>
      <OverviewComponent id="overview"  sourceID="container" width={'100%'} height={'250px'}/>
    </>);
}
const root = createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DataManager, Query } from '@syncfusion/ej2-data';
import { StackPanel, TextElement, DataBinding, OverviewComponent, HierarchicalTree, DiagramTools, DiagramComponent, Inject } from "@syncfusion/ej2-react-diagrams";
/**
 * Overview
 */
let data: object[] = [{
        'Id': 'parent',
        'Name': 'Maria Anders',
        'Designation': 'Managing Director',
        'IsExpand': 'true',
        'RatingColor': '#C34444'
    },
    {
        'Id': 1,
        'Name': 'Ana Trujillo',
        'Designation': 'Project Manager',
        'IsExpand': 'false',
        'RatingColor': '#68C2DE',
        'ReportingPerson': 'parent'
    },
    {
        'Id': 2,
        'Name': 'Anto Moreno',
        'Designation': 'Project Lead',
        'IsExpand': 'false',
        'RatingColor': '#93B85A',
        'ReportingPerson': 'parent'
    },
    {
        'Id': 3,
        'Name': 'Thomas Hardy',
        'Designation': 'Senior S/w Engg',
        'IsExpand': 'false',
        'RatingColor': '#68C2DE',
        'ReportingPerson': 1
    },
    {
        'Id': 4,
        'Name': 'Christina kaff',
        'Designation': 'S/w Engg',
        'IsExpand': 'false',
        'RatingColor': '#93B85A',
        'ReportingPerson': 2
    },
    {
        'Id': 5,
        'Name': 'Hanna Moos',
        'Designation': 'Project Trainee',
        'IsExpand': 'true',
        'RatingColor': '#D46E89',
        'ReportingPerson': 2
    },
];
let diagramInstance: DiagramComponent;
let items: DataManager = new DataManager(data as JSON[], new Query().take(7));
let layout: any = {
  type: 'HierarchicalTree',
  margin: {
    top: 20
  },
  getLayoutInfo: (node, tree) => {
    if (!tree.hasSubTree) {
      tree.orientation = 'Vertical';
      tree.type = 'Alternate';
    }
  },
}
// Initializes the Diagram control
function App() {
  return (
    <div>
      <div style=>
        <DiagramComponent
          id="container"
          ref={(diagram) => (diagramInstance = diagram)}
          height={'499px'}
          created={() => {
            //To draw an object once, activate draw once
            diagramInstance.tool = DiagramTools.ZoomPan;
            diagramInstance.dataBind();
          }}
          layout={layout}
          dataSourceSettings=
          getNodeDefaults={(node) => {
            node.height = 50;
            node.style.fill = '#6BA5D7';
            node.borderColor = 'white';
            node.style.strokeColor = 'white';
            return node;
          }}
          getConnectorDefaults={(obj) => {
            obj.style.strokeColor = '#6BA5D7';
            obj.style.fill = '#6BA5D7';
            obj.style.strokeWidth = 2;
            obj.targetDecorator.style.fill = '#6BA5D7';
            obj.targetDecorator.style.strokeColor = '#6BA5D7';
            obj.targetDecorator.shape = 'None';
            obj.type = 'Orthogonal';
            return obj;
          }}
          setNodeTemplate={(obj, diagram) => {
            let content = new StackPanel();
            content.id = obj.id + '_outerstack';
            content.style.strokeColor = 'darkgreen';
            content.style.fill = '#6BA5D7';
            content.orientation = 'Horizontal';
            content.padding = {
              left: 5,
              right: 10,
              top: 5,
              bottom: 5,
            };
            let innerStack = new StackPanel();
            innerStack.style.strokeColor = 'none';
            innerStack.style.fill = '#6BA5D7';
            innerStack.margin = {
              left: 5,
              right: 0,
              top: 0,
              bottom: 0,
            };
            innerStack.id = obj.id + '_innerstack';
            let text = new TextElement();
            text.content = obj.data['Name'];
            text.style.color = 'white';
            text.style.strokeColor = 'none';
            text.style.fill = 'none';
            text.id = obj.id + '_text1';
            let desigText = new TextElement();
            desigText.margin = {
              left: 0,
              right: 0,
              top: 5,
              bottom: 0,
            };
            desigText.content = obj.data['Designation'];
            desigText.style.color = 'white';
            desigText.style.strokeColor = 'none';
            desigText.style.fill = 'none';
            desigText.style.textWrapping = 'Wrap';
            desigText.id = obj.id + '_desig';
            innerStack.children = [text, desigText];
            content.children = [innerStack];
            return content;
          }}
        >
          <Inject services={[DataBinding, HierarchicalTree]} />
        </DiagramComponent>
      </div>
      <OverviewComponent
        id="overview"  
        sourceID="container"
        width={'100%'}
        height={'250px'}
      />
    </div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Overview-interaction

Troubleshooting

If the Overview appears blank, verify that the diagram’s id matches the Overview’s sourceID and that the target diagram is rendered before the Overview.

Overview in Angular Diagram

17 Aug 202618 minutes to read

The Overview component provides a miniature preview of the entire diagram content, enabling efficient navigation and viewport management for large diagrams. This component displays a scaled-down version of the diagram with a highlighted rectangle representing the current viewport, allowing users to quickly navigate to specific areas without manual zooming and panning.

When to Use Overview

The Overview component is essential when working with:

  • Large diagrams that exceed the visible viewport
  • Complex flowcharts or organizational charts requiring frequent navigation
  • Multi-section diagrams where users need to jump between different areas
  • Applications where users need spatial awareness of their current position within the diagram

Create Overview Component

To implement an overview, configure the sourceID property to reference the target diagram’s identifier. This establishes the connection between the overview and the main diagram. The OverviewComponent class hosts these properties.

Define the overview dimensions using the width and height properties to ensure optimal visibility and performance.

See the Overview API for the complete list of properties.

See Getting Started for project setup and module bootstrap.

The following code demonstrates basic overview implementation:

import { DiagramComponent, SnapSettingsModel, DiagramModule, OverviewModule, DataBindingService, HierarchicalTreeService, ScrollSettingsModel, SnapConstraints } from '@syncfusion/ej2-angular-diagrams'
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';


@Component({
imports: [
         DiagramModule, OverviewModule
    ],

providers: [DataBindingService, HierarchicalTreeService],
standalone: true,
    selector: "app-container",
    template: ` <div id="container" style="width: 100%; display: flex">
     <div id="element" style="flex: 7"><ejs-diagram #diagram id="diagram" width="100%" height="790px" [scrollSettings]="scrollSettings" [snapSettings]="snapSettings" >
     <e-nodes>
            <e-node id='node1' [offsetX]=400 [offsetY]=400 [height]=100  [width]=200  ></e-node>
        </e-nodes>
    </ejs-diagram>
    </div>
   <div style="flex: 3;height: 250px;padding: 0px;right: 30px;bottom: 20px;border: #eeeeee;border-style: solid;box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);
background: #f7f7f7;">
    <ejs-overview id="overview"  width= '300px'
  height= '150ppx' sourceID="diagram" >
        </ejs-overview>
</div>
        
</div>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public scrollSettings?: ScrollSettingsModel;
    public snapSettings?: SnapSettingsModel;
    //Initializes data 
    ngOnInit(): void {
        this.scrollSettings = {
            scrollLimit: 'Diagram',
           
        }
        this.snapSettings = {
            constraints: SnapConstraints.None
        }
    }
  
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Overview Interactions

The overview displays the current viewport as a red rectangle overlay. This rectangle serves as an interactive control for diagram navigation and zoom operations. The viewport rectangle color is fixed and cannot be customized.

Available Interactions

  • Resize the rectangle: Adjusts diagram zoom level proportionally
  • Drag the rectangle: Pans the diagram to follow rectangle movement
  • Click a position: Instantly navigates to the clicked location
  • Click and drag to select: Defines a specific region for navigation and zoom

Interactive Navigation Example

The following demonstration shows overview interaction capabilities:

Overview interaction demonstration

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, Diagram, NodeModel, ConnectorModel, SnapSettingsModel, LayoutModel, DataSourceModel, TextModel, DecoratorModel, ShapeStyleModel, DiagramModule, OverviewModule, DataBindingService, HierarchicalTreeService  } from '@syncfusion/ej2-angular-diagrams';
import { DataManager, Query } from '@syncfusion/ej2-data';

@Component({
imports: [
         DiagramModule, OverviewModule
    ],

providers: [DataBindingService, HierarchicalTreeService],
standalone: true,
    selector: "app-container",
    template: `<div><ejs-diagram #diagram id="diagram" width="100%" height="580px" [getNodeDefaults]="getNodeDefaults" [getConnectorDefaults]="getConnectorDefaults" [snapSettings]="snapSettings" [layout]="layout" [dataSourceSettings]="dataSourceSettings">
    </ejs-diagram></div>
    <div style=" width:50%; height: 200px padding:0px;right:5px;bottom:5px;background:#f7f7f7;position:absolute">
    <ejs-overview id="overview" width="100%" sourceID="diagram">
        </ejs-overview>
        </div>`,
    encapsulation: ViewEncapsulation.None
})
export class AppComponent {
    @ViewChild("diagram")
    public diagram?: DiagramComponent;
    public snapSettings?: SnapSettingsModel;
    public items?: DataManager;
    public layout?: LayoutModel;
    public dataSourceSettings?: DataSourceModel;
    //Initializes data source
    public data: object[] = [{
            Id: "parent",
            Role: "Project Management"
        },
        {
            Id: 1,
            Role: "R&D Team",
            Team: "parent"
        },
        {
            Id: 3,
            Role: "Philosophy",
            Team: "1"
        },
        {
            Id: 4,
            Role: "Organization",
            Team: "1"
        },
        {
            Id: 5,
            Role: "Technology",
            Team: "1"
        },
        {
            Id: 7,
            Role: "Funding",
            Team: "1"
        },
        {
            Id: 8,
            Role: "Resource Allocation",
            Team: "1"
        },
        {
            Id: 9,
            Role: "Targeting",
            Team: "1"
        },
        {
            Id: 11,
            Role: "Evaluation",
            Team: "1"
        },
        {
            Id: 156,
            Role: "HR Team",
            Team: "parent"
        },
        {
            Id: 13,
            Role: "Recruitment",
            Team: "156"
        },
        {
            Id: 113,
            Role: "Training",
            Team: "12"
        },
        {
            Id: 112,
            Role: "Employee Relation",
            Team: "156"
        },
        {
            Id: 14,
            Role: "Record Keeping",
            Team: "12"
        },
        {
            Id: 15,
            Role: "Compensations & Benefits",
            Team: "12"
        },
        {
            Id: 16,
            Role: "Compliances",
            Team: "12"
        },
        {
            Id: 17,
            Role: "Production & Sales Team",
            Team: "parent"
        },
        {
            Id: 119,
            Role: "Design",
            Team: "17"
        },
        {
            Id: 19,
            Role: "Operation",
            Team: "17"
        },
        {
            Id: 20,
            Role: "Support",
            Team: "17"
        },
        {
            Id: 21,
            Role: "Quality Assurance",
            Team: "17"
        },
        {
            Id: 23,
            Role: "Customer Interaction",
            Team: "17"
        },
        {
            Id: 24,
            Role: "Support and Maintenance",
            Team: "17"
        },
        {
            Id: 25,
            Role: "Task Coordination",
            Team: "17"
        }
    ];
    //Sets the default properties for all the Nodes
    public getNodeDefaults(obj: NodeModel, diagram: Diagram): NodeModel {
        obj.shape = {
            type: 'Text',
            content: (obj.data as {
                Role: 'string'
            }).Role
        };
        obj.style = {
            fill: 'None',
            strokeColor: 'none',
            strokeWidth: 2,
            bold: true,
            color: 'white'
        };
        obj.borderColor = 'white';
        obj.backgroundColor = '#6BA5D7';
        obj.borderWidth = 1;
        obj.width = 75;
        obj.height = 40;
        (obj.shape as TextModel).margin = {
            left: 5,
            right: 5,
            top: 5,
            bottom: 5
        };
        return obj;
    }
    //Sets the default properties for all the connectors
    public getConnectorDefaults(connector: ConnectorModel, diagram: Diagram): ConnectorModel {
        connector.style = {
            strokeColor: '#6BA5D7',
            strokeWidth: 2
        };
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).fill = '#6BA5D7';
        (((connector as ConnectorModel).targetDecorator as DecoratorModel).style as ShapeStyleModel).strokeColor = '#6BA5D7';
        connector.type = 'Orthogonal';
        return connector;
    }
    ngOnInit(): void {
        this.snapSettings = {
            constraints: 0
        }
        this.items = new DataManager(this.data as JSON[], new Query().take(5));
        //Uses layout to auto-arrange nodes on the Diagram page
        this.layout = {
            //set the type as Organizational Chart
            type: 'OrganizationalChart'
        }
        //Configures data source for Diagram
        this.dataSourceSettings = {
            id: 'Id',
            parentId: 'Team',
            dataSource: this.items
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Overview in Vue Diagram

06 Aug 202624 minutes to read

The Overview control allows you to see a preview or an overall view of the entire content of a Vue Diagram. This helps you to grasp the overall picture of a large diagram and navigate, pan, or zoom to a specific position on the page.

Usage scenario

When working on a very large diagram, it can be challenging to know which part you are actually focusing on or to navigate from one section to another. One solution for navigation is to zoom out to view the entire diagram and locate your position. Then, you can zoom in on the specific area you need. However, this method is not ideal for frequent navigation.

The Overview control addresses these issues by providing a preview, or overall view, of the entire diagram. A rectangle indicates the viewport of the diagram, making navigation easy by dragging this rectangle to the desired section.

Create overview

To create an overview, the sourceID property of the overview should be set with the corresponding diagram Id for the overall view.

The width and height properties of the overview allow you to define its size.

The following code illustrates how to create an overview:

<template>
   <div id="app" style="width: 100%; display: flex">
    <ejs-diagram id="diagram" :width='width' :height='height'  :nodes='nodes'  style="flex: 7;" :snapSettings='snapSettings' :scrollSettings='scrollSettings'></ejs-diagram>
    <div style="flex: 3;height: 250px;padding: 0px;right: 30px;bottom: 20px;border: #eeeeee;border-style: solid;box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);background: #f7f7f7;">
        <ejs-overview id="overview"  :sourceID='overviewsourceID' :width='overviewwidth' :height='overviewheight'></ejs-overview>
    </div>
</div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, OverviewComponent as EjsOverview,SnapConstraints } from '@syncfusion/ej2-vue-diagrams';

const nodes = [{id: 'node1', offsetX: 400, offsetY: 400, height: 100, width: 200}];
const width = "100%";
const height = "590px";
const snapSettings = {
    constraints: SnapConstraints.None 
};
const scrollSettings = {
    scrollLimit: 'Diagram'
};

const overviewsourceID = "diagram";
const overviewwidth = "300px";
const overviewheight = "150ppx";
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
<div id="app" style="width: 100%; display: flex">
    <ejs-diagram id="diagram" :width='width' :height='height'  :nodes='nodes'  style="flex: 7;" :snapSettings='snapSettings' :scrollSettings='scrollSettings'></ejs-diagram>
    <div style="flex: 3;height: 250px;padding: 0px;right: 30px;bottom: 20px;border: #eeeeee;border-style: solid;box-shadow: 0px 2px 2px rgba(0, 0, 0, 0.3);background: #f7f7f7;">
        <ejs-overview id="overview"  :sourceID='overviewsourceID' :width='overviewwidth' :height='overviewheight'></ejs-overview>
    </div>
</div>
</template>
<script>
import { DiagramComponent, OverviewComponent,SnapConstraints } from '@syncfusion/ej2-vue-diagrams';
let nodes = [{ id: 'node1', offsetX: 400, offsetY: 400, height: 100, width: 200 }];
export default {
name: "App",
components: {
    "ejs-diagram": DiagramComponent,
    "ejs-overview": OverviewComponent
},
data() {
    return {
        width: "100%",
        height: "590px",
        nodes: nodes,
        snapSettings: {
          constraints: SnapConstraints.None 
        },
        scrollSettings: { scrollLimit: 'Diagram' },
        overviewsourceID: "diagram",
        overviewwidth: "300px",
        overviewheight: "150ppx",
      }
        
},

}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Overview interactions

In the overview, the viewport of the diagram is highlighted with a red color rectangle. You can zoom and pan the diagram by interacting with this rectangle.

You can interact with the overview as follows:

  • Resize the rectangle: Zooms in/out of the diagram.
  • Drag the rectangle: Pans the diagram.
  • Click on a position: Navigates to the clicked region.
  • Select a specific region by clicking and dragging: Navigates to the specified region.
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
            :getConnectorDefaults='getConnectorDefaults' :snapSettings='snapSettings' :layout='layout'
            :dataSourceSettings='dataSourceSettings'>
        </ejs-diagram>
        <div style="right:0px;bottom:0px;background:#D5D5D5;position:absolute">
            <ejs-overview id="overview" style="top:30px" :sourceID='overviewsourceID' :width='overviewwidth'
                :height='overviewheight'>
            </ejs-overview>
        </div>
    </div>
</template>
<script setup>
import { provide } from "vue";
import { DiagramComponent as EjsDiagram, OverviewComponent as EjsOverview, DataBinding, StackPanel, TextElement, HierarchicalTree } from '@syncfusion/ej2-vue-diagrams';
import { DataManager, Query } from "@syncfusion/ej2-data";

const data = [{
    'Id': 'parent',
    'Name': 'Maria Anders',
    'Designation': 'Managing Director',
    'IsExpand': 'true',
    'RatingColor': '#C34444'
},
{
    'Id': 1,
    'Name': 'Ana Trujillo',
    'Designation': 'Project Manager',
    'IsExpand': 'false',
    'RatingColor': '#68C2DE',
    'ReportingPerson': 'parent'
},
{
    'Id': 2,
    'Name': 'Anto Moreno',
    'Designation': 'Project Lead',
    'IsExpand': 'false',
    'RatingColor': '#93B85A',
    'ReportingPerson': 'parent'
},
{
    'Id': 3,
    'Name': 'Thomas Hardy',
    'Designation': 'Senior S/w Engg',
    'IsExpand': 'false',
    'RatingColor': '#68C2DE',
    'ReportingPerson': 1
},
{
    'Id': 4,
    'Name': 'Christina kaff',
    'Designation': 'S/w Engg',
    'IsExpand': 'false',
    'RatingColor': '#93B85A',
    'ReportingPerson': 2
},
{
    'Id': 5,
    'Name': 'Hanna Moos',
    'Designation': 'Project Trainee',
    'IsExpand': 'true',
    'RatingColor': '#D46E89',
    'ReportingPerson': 2
}];

const items = new DataManager(data, new Query().take(7));

const width = "100%";
const height = "590px";
const snapSettings = {
    constraints: 0
}
const layout = {
    type: 'OrganizationalChart',
    margin: {
        top: 20
    },
    getLayoutInfo: (node, tree) => {
        if (!tree.hasSubTree) {
            tree.orientation = 'Vertical';
            tree.type = 'Alternate';
        }
    }
}
const dataSourceSettings = {
    id: 'Id',
    parentId: 'ReportingPerson',
    dataManager: items
}
const overviewsourceID = "diagram";
const overviewwidth = "100%";
const overviewheight = "150px";
const getNodeDefaults = (node) => {
    node.height = 50;
    node.style.fill = '#6BA5D7';
    node.style.borderColor = 'white';
    node.style.strokeColor = 'white';
    return node;
}
const getConnectorDefaults = (obj) => {
    obj.style.strokeColor = '#6BA5D7';
    obj.style.fill = '#6BA5D7';
    obj.style.strokeWidth = 2;
    obj.targetDecorator.style.fill = '#6BA5D7';
    obj.targetDecorator.style.strokeColor = '#6BA5D7';
    obj.targetDecorator.shape = 'None';
    obj.type = 'Orthogonal';
    return obj;
}
const setNodeTemplate = (obj, diagram) => {
    let content = new StackPanel();
    content.id = obj.id + '_outerstack';
    content.style.strokeColor = 'darkgreen';
    content.style.fill = '#6BA5D7';
    content.orientation = 'Horizontal';
    content.padding = {
        left: 5,
        right: 10,
        top: 5,
        bottom: 5
    };
    let innerStack = new StackPanel();
    innerStack.style.strokeColor = 'none';
    innerStack.style.fill = '#6BA5D7';
    innerStack.margin = {
        left: 5,
        right: 0,
        top: 0,
        bottom: 0
    };
    innerStack.id = obj.id + '_innerstack';
    let text = new TextElement();
    text.content = obj.data['Name'];
    text.style.color = 'white';
    text.style.strokeColor = 'none';
    text.style.fill = 'none';
    text.id = obj.id + '_text1';
    let desigText = new TextElement();
    desigText.margin = {
        left: 0,
        right: 0,
        top: 5,
        bottom: 0
    };
    desigText.content = obj.data['Designation'];
    desigText.style.color = 'white';
    desigText.style.strokeColor = 'none';
    desigText.style.fill = 'none';
    desigText.style.textWrapping = 'Wrap';
    desigText.id = obj.id + '_desig';
    innerStack.children = [text, desigText];
    content.children = [innerStack];
    return content;
}

provide('diagram', [DataBinding, HierarchicalTree]);
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
    <div id="app">
        <ejs-diagram id="diagram" :width='width' :height='height' :getNodeDefaults='getNodeDefaults'
            :getConnectorDefaults='getConnectorDefaults' :snapSettings='snapSettings' :layout='layout'
            :dataSourceSettings='dataSourceSettings'></ejs-diagram>
        <div style="right:0px;bottom:0px;background:#D5D5D5;position:absolute">
            <ejs-overview id="overview" style="top:30px" :sourceID='overviewsourceID' :width='overviewwidth'
                :height='overviewheight'></ejs-overview>
        </div>
    </div>
</template>
<script>
import { DiagramComponent, HierarchicalTree, DataBinding, OverviewComponent, StackPanel, TextElement } from '@syncfusion/ej2-vue-diagrams';
import { DataManager, Query } from "@syncfusion/ej2-data";

let data = [{
    'Id': 'parent',
    'Name': 'Maria Anders',
    'Designation': 'Managing Director',
    'IsExpand': 'true',
    'RatingColor': '#C34444'
},
{
    'Id': 1,
    'Name': 'Ana Trujillo',
    'Designation': 'Project Manager',
    'IsExpand': 'false',
    'RatingColor': '#68C2DE',
    'ReportingPerson': 'parent'
},
{
    'Id': 2,
    'Name': 'Anto Moreno',
    'Designation': 'Project Lead',
    'IsExpand': 'false',
    'RatingColor': '#93B85A',
    'ReportingPerson': 'parent'
},
{
    'Id': 3,
    'Name': 'Thomas Hardy',
    'Designation': 'Senior S/w Engg',
    'IsExpand': 'false',
    'RatingColor': '#68C2DE',
    'ReportingPerson': 1
},
{
    'Id': 4,
    'Name': 'Christina kaff',
    'Designation': 'S/w Engg',
    'IsExpand': 'false',
    'RatingColor': '#93B85A',
    'ReportingPerson': 2
},
{
    'Id': 5,
    'Name': 'Hanna Moos',
    'Designation': 'Project Trainee',
    'IsExpand': 'true',
    'RatingColor': '#D46E89',
    'ReportingPerson': 2
},
];
let items = new DataManager(data, new Query().take(7));

export default {
    name: "App",
    components: {
        "ejs-diagram": DiagramComponent,
        "ejs-overview": OverviewComponent
    },
    data() {
        return {
            width: "100%",
            height: "590px",
            snapSettings: {
                constraints: 0
            },
            layout: {
                type: 'OrganizationalChart',
                margin: {
                    top: 20
                },
                getLayoutInfo: (node, tree) => {
                    if (!tree.hasSubTree) {
                        tree.orientation = 'Vertical';
                        tree.type = 'Alternate';
                    }
                }
            },
            dataSourceSettings: {
                id: 'Id',
                parentId: 'ReportingPerson',
                dataManager: items
            },
            overviewsourceID: "diagram",
            overviewwidth: "100%",
            overviewheight: "150px",
            getNodeDefaults: (node) => {
                node.height = 50;
                node.style.fill = '#6BA5D7';
                node.style.borderColor = 'white';
                node.style.strokeColor = 'white';
                return node;
            },
            getConnectorDefaults: (obj) => {
                obj.style.strokeColor = '#6BA5D7';
                obj.style.fill = '#6BA5D7';
                obj.style.strokeWidth = 2;
                obj.targetDecorator.style.fill = '#6BA5D7';
                obj.targetDecorator.style.strokeColor = '#6BA5D7';
                obj.targetDecorator.shape = 'None';
                obj.type = 'Orthogonal';
                return obj;
            },
            setNodeTemplate: (obj, diagram) => {
                let content = new StackPanel();
                content.id = obj.id + '_outerstack';
                content.style.strokeColor = 'darkgreen';
                content.style.fill = '#6BA5D7';
                content.orientation = 'Horizontal';
                content.padding = {
                    left: 5,
                    right: 10,
                    top: 5,
                    bottom: 5
                };
                let innerStack = new StackPanel();
                innerStack.style.strokeColor = 'none';
                innerStack.style.fill = '#6BA5D7';
                innerStack.margin = {
                    left: 5,
                    right: 0,
                    top: 0,
                    bottom: 0
                };
                innerStack.id = obj.id + '_innerstack';
                let text = new TextElement();
                text.content = obj.data['Name'];
                text.style.color = 'white';
                text.style.strokeColor = 'none';
                text.style.fill = 'none';
                text.id = obj.id + '_text1';
                let desigText = new TextElement();
                desigText.margin = {
                    left: 0,
                    right: 0,
                    top: 5,
                    bottom: 0
                };
                desigText.content = obj.data['Designation'];
                desigText.style.color = 'white';
                desigText.style.strokeColor = 'none';
                desigText.style.fill = 'none';
                desigText.style.textWrapping = 'Wrap';
                desigText.id = obj.id + '_desig';
                innerStack.children = [text, desigText];
                content.children = [innerStack];
                return content;
            }
        }
    },
    provide: { diagram: [DataBinding, HierarchicalTree] }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Overview-interaction